#include "catch.hpp"

TEST_CASE("Vector size and capacity") {
	std::vector<int> vec;
	vec.push_back(1);
	vec.push_back(2);
	auto size = vec.size();
	REQUIRE(size == 2);
	SECTION("push_back increases size") {
		vec.push_back(3);
		REQUIRE(vec.size() > size);
	}
	SECTION("erase decreases size") {
		vec.erase(vec.begin());
		REQUIRE(vec.size() < size);
	}
}

SCENARIO("Adding an element to a vector") {
	GIVEN("A vector with no elements") {
		std::vector<int> vec;
		WHEN("an element is added via push_back") {
			vec.push_back(0);
			THEN("the size becomes 1") {
				REQUIRE(vec.size() == 1);
			}
		}
	}
}
